#!/usr/bin/env python
# -*- coding: utf-8 -*-
# ElbiaAdmin Python-lib version 2.1.8
# Copyright (c) 2012-2022, Jozef Sudolsky, ELBIA, s. r. o. (jozef@sudolsky.sk)
# All rights reserved.
# BSD Licence
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     1. Redistributions of source code must retain the above copyright notice,
#        this list of conditions and the following disclaimer.
#
#     2. Redistributions in binary form must reproduce the above copyright
#        notice, this list of conditions and the following disclaimer in the
#        documentation and/or other materials provided with the distribution.
#
#     3. Neither the name of ElbiaAdmin Python-lib nor the names of its
#        contributors may be used to endorse or promote products derived from
#        this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
################################################################################
import ealibCore

class ElbiaAdminInvoicing(ealibCore.ElbiaAdmin):

	OK_STATE = "ok"

	def getCompany(self, id):
		return self._do_command("getCompany", (self.__token__, id), "I")

	def getDocument(self, gid):
		return self._do_command("getDocument", (self.__token__, gid), "I")

	def listCompanies(self, pagingOffset, pagingCount, filName=None, filFirstname=None, filLastname=None, filStreet=None, filCity=None, filZip=None, filCountry=None, filEmail=None, filCid=None, filTid=None, filVid=None, filInvoiceVat=None, filNamePost=None, filStreetPost=None, filCityPost=None, filZipPost=None, filCountryPost=None):
		return self._do_command("listCompanies", (self.__token__, pagingOffset, pagingCount, filName, filFirstname, filLastname, filStreet, filCity, filZip, filCountry, filEmail, filCid, filTid, filVid, filInvoiceVat, filNamePost, filStreetPost, filCityPost, filZipPost, filCountryPost), "I")

	def listDocuments(self, pagingOffset, pagingCount, filId=None, filVS=None, filFkInvoice=None, filFkType=None, filName=None, filStreet=None, filCity=None, filZip=None, filCountry=None, filCid=None, filTid=None, filVid=None, filFkCurrency=None, filFkLanguage=None, filIssueDateFrom=None, filIssueDateTo=None, filDeliveryDateFrom=None, filDeliveryDateTo=None, filInvoiceVat=None, filAdvancePayment=None, filMaturityDays=None, filPrepaid=None, filKeyhash=None, filItemLabel=None, filPaid=None):
		return self._do_command("listDocuments", (self.__token__, pagingOffset, pagingCount, filId, filVS, filFkInvoice, filFkType, filName, filStreet, filCity, filZip, filCountry, filCid, filTid, filVid, filFkCurrency, filFkLanguage, filIssueDateFrom, filIssueDateTo, filDeliveryDateFrom, filDeliveryDateTo, filInvoiceVat, filAdvancePayment, filMaturityDays, filPrepaid, filKeyhash, filItemLabel, filPaid), "I")

	def setDocumentPaid(self, gid, paid):
		return self._do_command("setDocumentPaid", (self.__token__, gid, paid), "I")

	def setDocumentStorno(self, gid, storno):
		return self._do_command("setDocumentStorno", (self.__token__, gid, storno), "I")

	def createInvoiceFromTicket(self, gid, issueDate, deliveryDate, advancePayment, maturityDays, prepaid):
		return self._do_command("createInvoiceFromTicket", (self.__token__, gid, issueDate, deliveryDate, advancePayment, maturityDays, prepaid), "I")

"""
EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE
EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE
EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE

import ealibInvoicing

eai = ealibInvoicing.ElbiaAdminInvoicing("login", "heslo")

result = eai.listDocuments(0, 10, None, None, None, 1)

print result
"""
