#!/usr/bin/env python
# -*- coding: utf-8 -*-
# ElbiaAdmin Python-lib version 2.1.8
# Copyright (c) 2012-2022, Jozef Sudolsky, ELBIA, s. r. o. (jozef@sudolsky.sk)
# All rights reserved.
# BSD Licence
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     1. Redistributions of source code must retain the above copyright notice,
#        this list of conditions and the following disclaimer.
#
#     2. Redistributions in binary form must reproduce the above copyright
#        notice, this list of conditions and the following disclaimer in the
#        documentation and/or other materials provided with the distribution.
#
#     3. Neither the name of ElbiaAdmin Python-lib nor the names of its
#        contributors may be used to endorse or promote products derived from
#        this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
################################################################################
import ealibCore

class ElbiaAdminSubHoster(ealibCore.ElbiaAdmin):

	OK_STATE = "ok"

	def get_news_subhoster(self, poffset, pcount):
		return self._do_command("get_news_subhoster", (self.__token__, poffset, pcount), "DI")

	def get_price_list_domains_subhoster(self, fid_interface=None):
		return self._do_command("get_price_list_domains_subhoster", (self.__token__, fid_interface), "DI")

	def check_domain_password(self, domain, tld):
		return self._do_command("check_domain_password", (self.__login__, self.__password__, domain, tld), "DI", add_token=False)

	def get_webhosting_package(self, pack_id):
		return self._do_command("get_webhosting_package", (self.__token__, pack_id), "DI")

	def get_webhosting_packages(self, fid_interface=None):
		return self._do_command("get_webhosting_packages", (self.__token__, fid_interface), "DI")

	def get_webhosting_domains_count_subhoster(self):
		return self._do_command("get_webhosting_domains_count_subhoster", (self.__token__,), "DI")

	def check_user_login(self, login):
		return self._do_command("check_user_login", (self.__token__, login), "DI")

	def get_references_password(self, count, reg_only):
		return self._do_command("get_references_password", (self.__login__, self.__password__, count, reg_only), "DI", add_token=False)

	def get_webhosting_domains_subhoster(self, poffset, pcount, fdomain=None, ftld=None, flogin=None, fcustomersgroup=None, fexpirationfrom=None, fexpirationto=None, fip=None, fipv6=None):
		return self._do_command("get_webhosting_domains_subhoster", (self.__token__, poffset, pcount, fdomain, ftld, flogin, fcustomersgroup, fexpirationfrom, fexpirationto, fip, fipv6), "DI")

	def get_webhosting_domain_by_name_subhoster(self, domain, tld):
		return self._do_command("get_webhosting_domain_by_name_subhoster", (self.__token__, domain, tld), "DI")

	def change_webhosting_domain_subhoster(self, dom_id, id_service, id_ip):
		return self._do_command("change_webhosting_domain_subhoster", (self.__token__, dom_id, id_service, id_ip), "DI")

	def get_order_subhoster(self, order_id):
		return self._do_command("get_order_subhoster", (self.__token__, order_id), "DI")

	def get_orders_subhoster(self, poffset, pcount, fticket_number=None, flogin=None, factivated=None, fpaid=None, fcanceled=None):
		return self._do_command("get_orders_subhoster", (self.__token__, poffset, pcount, fticket_number, flogin, factivated, fpaid, fcanceled), "DI")

	def get_interfaces_subhoster(self):
		return self._do_command("get_interfaces_subhoster", (self.__token__,), "DI")

	def get_interface_subhoster(self, id_interface):
		return self._do_command("get_interface_subhoster", (self.__token__, id_interface), "DI")

	def add_interface_subhoster(self, name):
		return self._do_command("add_interface_subhoster", (self.__token__, name), "DI")

	def change_interface_subhoster(self, id_interface, name):
		return self._do_command("change_interface_subhoster", (self.__token__, id_interface, name), "DI")

	def remove_interface_subhoster(self, id_interface):
		return self._do_command("remove_interface_subhoster", (self.__token__, id_interface), "DI")

	def set_paid_order_subhoster(self, order_id, delivery_date=None):
		return self._do_command("set_paid_order_subhoster", (self.__token__, order_id, delivery_date), "DI")

	def activate_order_subhoster(self, order_id):
		return self._do_command("activate_order_subhoster", (self.__token__, order_id), "DI")

	def get_webhosting_subhoster(self, id_service):
		return self._do_command("get_webhosting_subhoster", (self.__token__, id_service), "DI")

	def get_webhostings_subhoster(self, poffset, pcount, flogin=None, fgroup=None, femail=None, fpackage=None, fpackage_type=None, fexpirationfrom=None, fexpirationto=None):
		return self._do_command("get_webhostings_subhoster", (self.__token__, poffset, pcount, flogin, fgroup, femail, fpackage, fpackage_type, fexpirationfrom, fexpirationto), "DI")

	def add_webhosting_subhoster(self, login, password, email, iemail, cell, lang, person_type, title, fname, lname, company, street, town, zip, country, cid, tid, vid, id_pack, expiration, payment, payment_system, renewal_type, addons_add, ip_addresses, groups):
		return self._do_command("add_webhosting_subhoster", (self.__token__, login, password, email, iemail, cell, lang, person_type, title, fname, lname, company, street, town, zip, country, cid, tid, vid, id_pack, expiration, payment, payment_system, renewal_type, addons_add, ip_addresses, groups), "DI")

	def order_webhosting_subhoster(self, login, password, email, iemail, cell, lang, person_type, title, fname, lname, company, street, town, zip, country, cid, tid, vid, id_pack, payment, domains, addons, message=None, coupon=None):
		return self._do_command("order_webhosting_subhoster", (self.__token__, login, password, email, iemail, cell, lang, person_type, title, fname, lname, company, street, town, zip, country, cid, tid, vid, id_pack, payment, domains, addons, message, coupon), "DI")

	def change_webhosting_subhoster(self, id_service, id_pack, password, expiration, payment, payment_system, renewal_type, addons_add, addons_del, ip_addresses, groups, delete_after_expiration):
		return self._do_command("change_webhosting_subhoster", (self.__token__, id_service, id_pack, password, expiration, payment, payment_system, renewal_type, addons_add, addons_del, ip_addresses, groups, delete_after_expiration), "DI")

	def renew_webhosting_subhoster(self, id_service):
		return self._do_command("renew_webhosting_subhoster", (self.__token__, id_service), "DI")

	def remove_webhosting_subhoster(self, id_service):
		return self._do_command("remove_webhosting_subhoster", (self.__token__, id_service), "DI")

	def get_webhosting_usage_subhoster(self, id_service):
		return self._do_command("get_webhosting_usage_subhoster", (self.__token__, id_service), "DI")

	def get_webhosting_domains_subhoster(self, poffset, pcount, fdomain=None, ftld=None, flogin=None, fcustomersgroup=None, fexpirationfrom=None, fexpirationto=None, fipv4=None, fipv6=None):
		return self._do_command("get_webhosting_domains_subhoster", (self.__token__, poffset, pcount, fdomain, ftld, flogin, fcustomersgroup, fexpirationfrom, fexpirationto, fipv4, fipv6), "DI")

	def get_webhosting_domain_subhoster(self, dom_id):
		return self._do_command("get_webhosting_domain_subhoster", (self.__token__, dom_id), "DI")

	def get_webhosting_domain_by_name_subhoster(self, domain, tld):
		return self._do_command("get_webhosting_domain_by_name_subhoster", (self.__token__, domain, tld), "DI")

	def add_webhosting_domain_subhoster(self, domain, tld, id_service, id_ip, id_domain, hosting):
		return self._do_command("add_webhosting_domain_subhoster", (self.__token__, domain, tld, id_service, id_ip, id_domain, hosting), "DI")

	def change_webhosting_domain_subhoster(self, dom_id, id_service, id_ip):
		return self._do_command("change_webhosting_domain_subhoster", (self.__token__, dom_id, id_service, id_ip), "DI")

	def set_state_webhosting_domain_subhoster(self, dom_id, states, send_notification, note):
		return self._do_command("set_state_webhosting_domain_subhoster", (self.__token__, dom_id, states, send_notification, note), "DI")

	def remove_webhosting_domain_subhoster(self, dom_id):
		return self._do_command("remove_webhosting_domain_subhoster", (self.__token__, dom_id), "DI")
