#!/usr/bin/env python
# -*- coding: utf-8 -*-
# ElbiaAdmin Python-lib version 2.1.8
# Copyright (c) 2010-2022, Jozef Sudolsky, ELBIA, s. r. o. (jozef@sudolsky.sk)
# All rights reserved.
# BSD Licence
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     1. Redistributions of source code must retain the above copyright notice,
#        this list of conditions and the following disclaimer.
#
#     2. Redistributions in binary form must reproduce the above copyright
#        notice, this list of conditions and the following disclaimer in the
#        documentation and/or other materials provided with the distribution.
#
#     3. Neither the name of ElbiaAdmin Python-lib nor the names of its
#        contributors may be used to endorse or promote products derived from
#        this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
################################################################################

import ealibCore

class ElbiaAdminWebhosting(ealibCore.ElbiaAdmin):

	def get_email_account(self, email_id):
		return self._do_command("get_email_account", (self.__token__, email_id), "M")

	def get_email_accounts(self, domain, tld, poffset, pcount, fname=None):
		return self._do_command("get_email_accounts", (self.__token__, domain, tld, poffset, pcount, fname), "M")

	def add_email_account(self, name, domain, tld, password, catchall, antispam):
		return self._do_command("add_email_account", (self.__token__, name, domain, tld, password, catchall, antispam), "M")

	def change_email_account(self, email_id, password, catchall, antispam, bcc_in, bcc_out):
		return self._do_command("change_email_account", (self.__token__, email_id, password, catchall, antispam, bcc_in, bcc_out), "M")

	def remove_email_account(self, email_id):
		return self._do_command("remove_email_account", (self.__token__, email_id), "M")

	def get_email_autoreply(self, email_id):
		return self._do_command("get_email_autoreply", (self.__token__, email_id), "M")

	def change_email_autoreply(self, id_email, subject, text, content_type, forward, activate, deactivate, dayw, active):
		return self._do_command("change_email_autoreply", (self.__token__, id_email, subject, text, content_type, forward, activate, deactivate, dayw, active), "M")

	def get_email_filters(self, email_id):
		return self._do_command("get_email_filters", (self.__token__, email_id), "M")

	def get_email_filter(self, filter_id):
		return self._do_command("get_email_filter", (self.__token__, filter_id), "M")

	def add_email_filter(self, email_id, name, conditions_type, action, action_info, rules):
		return self._do_command("add_email_filter", (self.__token__, email_id, name, conditions_type, action, action_info, rules), "M")

	def change_email_filter(self, filter_id, name):
		return self._do_command("change_email_filter", (self.__token__, filter_id, name), "M")

	def activate_email_filter(self, filter_id):
		return self._do_command("activate_email_filter", (self.__token__, filter_id), "M")

	def deactivate_email_filter(self, filter_id):
		return self._do_command("deactivate_email_filter", (self.__token__, filter_id), "M")

	def remove_email_filter(self, filter_id):
		return self._do_command("remove_email_filter", (self.__token__, filter_id), "M")

	def get_email_aliases(self, domain, tld, poffset, pcount, fname=None, faccount=None):
		return self._do_command("get_email_aliases", (self.__token__, domain, tld, poffset, pcount, fname, faccount), "M")

	def add_email_alias(self, name, account_id):
		return self._do_command("add_email_alias", (self.__token__, name, account_id), "M")

	def remove_email_alias(self, alias_id):
		return self._do_command("remove_email_alias", (self.__token__, alias_id), "M")

	def get_email_forwards(self, domain, tld, poffset, pcount, fname=None, femails=None):
		return self._do_command("get_email_forwards", (self.__token__, domain, tld, poffset, pcount, fname, femails), "M")

	def get_email_forward(self, account_id):
		return self._do_command("get_email_forward", (self.__token__, account_id), "M")

	def add_email_forward(self, account_id, emails, save):
		return self._do_command("add_email_forward", (self.__token__, account_id, emails, save), "M")

	def change_email_forward(self, account_id, emails, save):
		return self._do_command("change_email_forward", (self.__token__, account_id, emails, save), "M")

	def remove_email_forward(self, account_id):
		return self._do_command("remove_email_forward", (self.__token__, account_id), "M")

	def get_quota(self):
		return self._do_command("get_quota", (self.__token__,), "W")

	def list_dir(self, directory, files=0):
		return self._do_command("list_dir", (self.__token__, directory, files), "W")

	def create_dir(self, directory, name):
		return self._do_command("create_dir", (self.__token__, directory, name), "W")

	def get_ftp_account(self, ftp_id):
		return self._do_command("get_ftp_account", (self.__token__, ftp_id), "W")

	def get_ftp_accounts(self, poffset, pcount, fuserid=None, fhomedir=None):
		return self._do_command("get_ftp_accounts", (self.__token__, poffset, pcount, fuserid, fhomedir), "W")

	def add_ftp_account(self, login, password, directory):
		return self._do_command("add_ftp_account", (self.__token__, login, password, directory), "W")

	def change_ftp_account(self, ftp_id, password, directory):
		return self._do_command("change_ftp_account", (self.__token__, ftp_id, password, directory), "W")

	def activate_ftp_account(self, ftp_id):
		return self._do_command("activate_ftp_account", (self.__token__, ftp_id), "W")

	def deactivate_ftp_account(self, ftp_id):
		return self._do_command("deactivate_ftp_account", (self.__token__, ftp_id), "W")

	def remove_ftp_account(self, ftp_id):
		return self._do_command("remove_ftp_account", (self.__token__, ftp_id), "W")

	def get_ftp_ipfilters(self, ftp_id):
		return self._do_command("get_ftp_ipfilters", (self.__token__, ftp_id), "W")

	def add_ftp_ipfilter(self, ftp_id, rule, rtype):
		return self._do_command("add_ftp_ipfilter", (self.__token__, ftp_id, rule, rtype), "W")

	def remove_ftp_ipfilter(self, rule_id):
		return self._do_command("remove_ftp_ipfilter", (self.__token__, rule_id), "W")

	def get_logs(self, domain, tld, ltype):
		return self._do_command("get_logs", (self.__token__, domain, tld, ltype), "W")

	def show_log(self, domain, tld, ltype, log):
		return self._do_command("show_log", (self.__token__, domain, tld, ltype, log), "W")

	def copy_log(self, domain, tld, ltype, log):
		return self._do_command("copy_log", (self.__token__, domain, tld, ltype, log), "W")

	def get_subdomains(self, domain, tld, poffset, pcount, fsubdomain=None, frootdir=None, fjail=None):
		return self._do_command("get_subdomains", (self.__token__, domain, tld, poffset, pcount, fsubdomain, frootdir, fjail), "W")

	def get_subdomain(self, sub_id):
		return self._do_command("get_subdomain", (self.__token__, sub_id), "W")

	def add_subdomain(self, subdomain, domain, tld, directory, jail, https, force_https, redirect, https_certificate, https_private_key, https_ca_certificate, id_php, php_private_pool, php_file_cache, wsgi, firewall):
		return self._do_command("add_subdomain", (self.__token__, subdomain, domain, tld, directory, jail, https, force_https, redirect, https_certificate, https_private_key, https_ca_certificate, id_php, php_private_pool, php_file_cache, wsgi, wsgi, firewall), "W")

	def change_subdomain(self, sub_id, directory, jail, https, force_https, redirect, https_certificate, https_private_key, https_ca_certificate, id_php, php_private_pool, php_file_cache, wsgi, firewall):
		return self._do_command("change_subdomain", (self.__token__, sub_id, directory, jail, https, force_https, redirect, https_certificate, https_private_key, https_ca_certificate, id_php, php_private_pool, php_file_cache, wsgi, wsgi, firewall), "W")

	def remove_subdomain(self, sub_id):
		return self._do_command("remove_subdomain", (self.__token__, sub_id), "W")

	def get_subdomain_software_info(self, sub_id):
		return self._do_command("get_subdomain_software_info", (self.__token__, sub_id), "W")

	def change_subdomain_software_info(self, sub_id, info):
		return self._do_command("change_subdomain_software_info", (self.__token__, sub_id, info), "W")

	def get_supported_phps(self):
		return self._do_command("get_supported_phps", (self.__token__), "W")

	def get_mysql_accounts(self, poffset, pcount, fuser=None, fhost=None):
		return self._do_command("get_mysql_accounts", (self.__token__, poffset, pcount, fuser, fhost), "W")

	def add_mysql_account(self, login, host, password):
		return self._do_command("add_mysql_account", (self.__token__, login, host, password), "W")

	def change_mysql_account(self, acc_id, host, password):
		return self._do_command("change_mysql_account", (self.__token__, acc_id, host, password), "W")

	def remove_mysql_account(self, acc_id):
		return self._do_command("remove_mysql_account", (self.__token__, acc_id), "W")

	def get_mysql_encodings(self):
		return self._do_command("get_mysql_encodings", (self.__token__,), "W")

	def get_mysql_databases(self, poffset, pcount, fdb=None):
		return self._do_command("get_mysql_databases", (self.__token__, poffset, pcount, fdb), "W")

	def get_mysql_database(self, db_id):
		return self._do_command("get_mysql_database", (self.__token__, db_id), "W")

	def add_mysql_database(self, name, encoding, account):
		return self._do_command("add_mysql_database", (self.__token__, name, encoding, account), "W")

	def change_mysql_database(self, db_id, account):
		return self._do_command("change_mysql_database", (self.__token__, db_id, account), "W")

	def remove_mysql_database(self, db_id):
		return self._do_command("remove_mysql_database", (self.__token__, db_id), "W")

	def restore_mysql_database(self, db_id):
		return self._do_command("restore_mysql_database", (self.__token__, db_id), "W")

	def get_crons(self, poffset, pcount, fname=None, femail=None, fcfile=None, fsubdomain=None, fdomain=None, ftld=None, furl=None):
		return self._do_command("get_crons", (self.__token__, poffset, pcount, fname, femail, fcfile, fsubdomain, fdomain, ftld, furl), "W")

	def get_cron(self, cron_id):
		return self._do_command("get_cron", (self.__token__, cron_id), "W")

	def add_cron(self, name, email, ctype, cfile, parameters, proto, subdomain, domain, tld, url, auth_login, auth_password, minute, hour, day, month, dayw):
		return self._do_command("add_cron", (self.__token__, name, email, ctype, cfile, parameters, proto, subdomain, domain, tld, url, auth_login, auth_password, minute, hour, day, month, dayw), "W")

	def change_cron(self, cron_id, name, email, ctype, cfile, parameters, proto, subdomain, domain, tld, url, auth_login, auth_password, minute, hour, day, month, dayw):
		return self._do_command("change_cron", (self.__token__, cron_id, name, email, ctype, cfile, parameters, proto, subdomain, domain, tld, url, auth_login, auth_password, minute, hour, day, month, dayw), "W")

	def remove_cron(self, cron_id):
		return self._do_command("remove_cron", (self.__token__, cron_id), "W")

	def get_webhosting_info(self):
		return self._do_command("get_webhosting_info", (self.__token__,), "DI")

	def get_webhosting_ip_addresses(self, get_domains=0):
		return self._do_command("get_webhosting_ip_addresses", (self.__token__, get_domains), "DI")

	def renew_webhosting(self):
		return self._do_command("renew_webhosting", (self.__token__,), "DI")

	def renew_webhosting_domain(self, dom_id):
		return self._do_command("renew_webhosting_domain", (self.__token__, dom_id), "DI")

	def get_webhosting_domain(self, dom_id):
		return self._do_command("get_webhosting_domain", (self.__token__, dom_id), "DI")

	def get_webhosting_domain_by_name(self, domain, tld):
		return self._do_command("get_webhosting_domain_by_name", (self.__token__, domain, tld), "DI")

	def get_webhosting_domains(self, poffset, pcount, fdomain=None, ftld=None, fexpirationfrom=None, fexpirationto=None, fipv4=None, fipv6=None):
		return self._do_command("get_webhosting_domains", (self.__token__, poffset, pcount, fdomain, ftld, fexpirationfrom, fexpirationto, fipv4, fipv6), "DI")

	def add_webhosting_domain(self, domain, tld, id_ip, id_domain):
		return self._do_command("add_webhosting_domain", (self.__token__, domain, tld, id_ip, id_domain), "DI")

	def change_webhosting_domain(self, dom_id, id_ip):
		return self._do_command("change_webhosting_domain", (self.__token__, dom_id, id_ip), "DI")

	def change_webhosting_domain_dns_servers(self, dom_id, ns1, ns2, ns3, ns4, ip1, ip2, ip3, ip4, nsset):
		return self._do_command("change_webhosting_domain_dns_servers", (self.__token__, dom_id, ns1, ns2, ns3, ns4, ip1, ip2, ip3, ip4, nsset), "DI")

	def remove_webhosting_domain(self, dom_id):
		return self._do_command("remove_webhosting_domain", (self.__token__, dom_id), "DI")

	def register_webhosting_domain(self, domain, tld, owner, id_domain):
		return self._do_command("register_webhosting_domain", (self.__token__, domain, tld, owner, id_domain), "DI")

	def get_domain_dns_records(self, domain, tld):
		return self._do_command("get_domain_dns_records", (self.__token__, domain, tld), "D")

	def get_domain_dns_record(self, record_id):
		return self._do_command("get_domain_dns_record", (self.__token__, record_id), "D")

	def add_domain_dns_record(self, domain, tld, name, rtype, content, ttl, prio):
		return self._do_command("add_domain_dns_record", (self.__token__, domain, tld, name, rtype, content, ttl, prio), "D")

	def change_domain_dns_record(record_id, name, rtype, content, ttl, prio):
		return self._do_command("change_domain_dns_record", (self.__token__, record_id, name, rtype, content, ttl, prio), "D")

	def remove_domain_dns_record(self, record_id):
		return self._do_command("remove_domain_dns_record", (self.__token__, record_id), "D")

	def set_stats_password(self, domain, tld, login, password):
		return self._do_command("set_stats_password", (self.__token__, domain, tld, record_id), "W")

	def add_temporary_url(self, sub_id):
		return self._do_command("add_temporary_url", (self.__token__, domain, tld, record_id), "W")

	def get_running_processes(self):
		return self._do_command("get_running_processes", (self.__token__,), "W")

	def kill_running_process(self, pid):
		return self._do_command("kill_running_process", (self.__token__, pid), "W")

	def get_mysql_running_processes(self):
		return self._do_command("get_mysql_running_processes", (self.__token__,), "W")

	def kill_mysql_running_process(self, pid):
		return self._do_command("kill_mysql_running_process", (self.__token__, pid), "W")

	def get_webhosting_tlds(self):
		return self._do_command("get_webhosting_tlds", (self.__token__,), "DI")

	def import_info(self, id_email):
		return self._do_command("import_info", (self.__token__, id_email), "M")

	def start_import(self, id_email, host, port, login, password, ssl, email):
		return self._do_command("start_import", (self.__token__, id_email, host, port, login, password, ssl, email), "M")

	def install_software_subdomain(sub_id, software, email, site_name):
		return self._do_command("install_software_subdomain", (self.__token__, sub_id, software, email, site_name), "W")

	def change_ssh_password(self, password):
		return self._do_command("change_ssh_password", (self.__token__, password), "W")

	def get_webhosting_cpu_graph(self, period):
		return self._do_command("get_webhosting_cpu_graph", (self.__token__, period), "DI")

"""
EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE
EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE
EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE

import ealibWebhosting

eaw = ealibWebhosting.ElbiaAdminWebhosting("login", "heslo")

result = eaw.get_webhosting_domains(0, 0)

print result

result = eaw.get_email_accounts("inetadmin", "eu", 0, 0)

print result

result = eaw.add_email_account("info", "inetadmin", "eu", "dd", 0)

print result

result = eaw.change_email_account(1108, "ff", 0)

print result

result = eaw.remove_email_account(1108)

print result
"""
